#!/system/bin/busybox sh
####################################################
############ SYSTEM INTEGRITY TEST #################
####################################################
checksum_mismatch_file="/data/errorLog/checksum_mismatch.json"
echo '{"checksum_mismatch_files":['>$checksum_mismatch_file
checkFlag=0
CHECKSUM_INPUT="/data/patch/system_manifest_checksum.txt"

if busybox test -f $CHECKSUM_INPUT
then
exec 0< $CHECKSUM_INPUT
while read line
do
	PATCH_FILE_ROW_NAME='/'$(echo $line | busybox awk '{ print $1 }')
	o_checksum=$(echo $line | busybox awk '{ print $3 }')
	if busybox test ! -f $PATCH_FILE_ROW_NAME 
	then
		echo '{"file_name":"'$PATCH_FILE_ROW_NAME'","panel_checksum":"0","master_checksum":"'$o_checksum'"},'>>$checksum_mismatch_file
		checkFlag=1
		continue
	fi

	c_checksum=`busybox cat $PATCH_FILE_ROW_NAME| busybox md5sum| busybox cut -d" " -f1`
	if echo $line | busybox grep $c_checksum >/dev/null 2>&1
	then		
		continue		
	else	
		checkFlag=1
		echo '{"file_name":"'$PATCH_FILE_ROW_NAME'","panel_checksum":"'$c_checksum'","master_checksum":"'$o_checksum'"},'>>$checksum_mismatch_file
	fi
done
fi

if busybox test $checkFlag -eq 0
then
	setprop qol.integrity_test_result 1
	rm $checksum_mismatch_file
else
	setprop qol.integrity_test_result 0
	x=`cat $checksum_mismatch_file`
	echo ${x%?}>$checksum_mismatch_file
	echo ']}'>>$checksum_mismatch_file
fi
