#!/system/bin/busybox sh
insmod /system/lib/modules/recovd.ko
insmod /system/lib/modules/bmm.ko bmm_size_mb=32
chmod 777 /dev/bma220
chmod 777 /dev/foxled
chmod 777 /dev/phara

#disable PM suspend temprarily
#echo disable_pm_suspend > /sys/power/wake_lock
#enable low power mode
echo 1 > /sys/power/mspm/mspm
echo /dev/block/mmcblk0 > /sys/devices/platform/usb_mass_storage.0/lun0/file

setprop wlan.driver.status ok
#START-CHS
curr_date=`date +%Y%m%d%H%M%S`
DEBUG_LOG="/data/errorLog/upandroid/upandroid_"$curr_date".log"
echo `date`" Cleaning up P7 file system">>$DEBUG_LOG
busybox umount /mnt/internalstorage
fsck_msdos -p -f /dev/block/mmcblk0p7 >>$DEBUG_LOG
echo `date`" Remounting /mnt/internalstorage as Read Write">>$DEBUG_LOG
busybox mount /dev/block/mmcblk0p7 /mnt/internalstorage
busybox mount -o rw,remount /mnt/internalstorage

#echo `date`" Remounting system as Read Write">>$DEBUG_LOG
#busybox mount -o ro,remount /system
#echo "y" | e2fsck -pcfv /dev/block/mmcblk0p2 >>$DEBUG_LOG
busybox mount -o rw -o remount /system

if [ -f "/data/patch/power.txt" ]; then
	busybox rm "/data/patch/power.txt"
	hwapitest c hrled
	hwapitest c brled
    wd.sh &
	  # if PIC VERSION Less than V80_XX then busybox poweroff -f else hwapitest c systemshutdown
	   #PIC_VERSION=`testeepapi r syspic | busybox cut -d _ -f1 | busybox cut -d V -f2`
	   PIC_VERSION=`pictl r 0x6 0x2 | busybox cut -d ' '  -f3`
	   echo $PIC_VERSION
	   if [ $PIC_VERSION -lt 80 ]; then
		busybox poweroff -f
	   elif [ $PIC_VERSION -ge 80 ]; then
		sleep 5
		hwapitest c systemshutdown	
	   fi
	   exit 0
fi

#setting properties for adbd
setprop service.adb.tcp.port 5555
stop adbd
#start adbd

#enable panic on oom, this reboot the system after 60sec timeout
#set the overcommit_ratio to 80 for increasing the oom memory threshold
echo 1 > /proc/sys/vm/panic_on_oom

echo 80 > /proc/sys/vm/overcommit_ratio

echo 60 > /proc/sys/kernel/panic
#QOLSYS
echo 1 >/proc/sys/kernel/hung_task_panic

echo 1 >/proc/sys/kernel/softlockup_panic

echo 360 > /proc/sys/kernel/hung_task_timeout_secs

busybox chmod 777 /data
busybox chmod 777 /system/etc/system_manifest.txt
busybox chmod -R 777 /data/logs/
busybox chmod -R 777 /mnt/internalstorage/logs/
busybox chmod -R 755 /system/bin/*                                              
busybox chmod -R 777 /system/app/*      
busybox chmod -R 755 /system/xbin/* 
busybox chmod -R 644 /data/tombstones/*
busybox mkdir -p /mnt/internalstorage/alarms
#busybox mkdir -p /mnt/internalstorage/videoMemos
#busybox mkdir -p /mnt/internalstorage/disarmPhotos
busybox mkdir -p /mnt/internalstorage/Panel_FAQVideos
busybox mkdir -p /mnt/internalstorage/Panel_Music
#busybox mkdir -p /mnt/internalstorage/ImageSensor
busybox mkdir -p /mnt/internalstorage/photoframe
busybox mkdir -p "/data/srfhal"
busybox mkdir -p "/data/patch"
busybox mkdir -p "/data/ver"
busybox chmod 4755 /system/bin/busybox
busybox chmod -R 777 /data/data/com.qolsys.logs/
busybox mkdir -p /data/errorLog
busybox mkdir -p /data/errorLog/upandroid
busybox mkdir -p /data/errorLog/kernel
busybox chmod 666 /data/errorLog/kernel/*
busybox chmod 666 /data/errorLog/nhlog*.log
busybox mv /data/errorLog/nhlog*.log /data/errorLog/kernel/
busybox mv /data/errorLog/upandroid*.log /data/errorLog/upandroid/
#Moving P7 media data to P3
busybox mkdir -p /data/media/alarmPhotos
busybox mkdir -p /data/media/disarmPhotos
busybox mkdir -p /data/media/ImageSensor
chown system.system /data/media/alarmPhotos
chown system.system /data/media/disarmPhotos
chown system.system /data/media/ImageSensor
busybox cp -Rf /mnt/internalstorage/alarmPhotos/ /data/media/
busybox cp -Rf /mnt/internalstorage/disarmPhotos/ /data/media/        
busybox cp -Rf /mnt/internalstorage/ImageSensor/ /data/media/ 
busybox rm -rf /mnt/internalstorage/alarmPhotos/         
busybox rm -rf /mnt/internalstorage/disarmPhotos/        
busybox rm -rf /mnt/internalstorage/ImageSensor/

linux_version=`busybox uname -r`
setprop KERNEL_VERSION $linux_version
#/system/bin/recovd &
#/system/bin/shelld &
#/system/bin/remoteComm &
/system/bin/klogd&

if [ ! -f "/data/patch/system_manifest.txt" ]; then
if [ -f "/mnt/internalstorage/system_manifest.txt" ]; then
busybox mv /mnt/internalstorage/system_manifest.txt /data/patch 
else 
busybox cp /system/etc/system_manifest.txt /data/patch/
fi
elif [ -f "/mnt/internalstorage/system_manifest.txt" ]; then
busybox rm /mnt/internalstorage/system_manifest.txt
fi

if [ -f "/mnt/internalstorage/QOLSYS.db" ]; then
busybox mv /mnt/internalstorage/QOLSYS.db /data/patch
fi

if [ -f "/mnt/internalstorage/upgrade" ]; then
busybox mv /mnt/internalstorage/upgrade /data/patch
fi

if [ -f "/data/patch/QOLSYS.db" ]; then
busybox chmod -R 777 /data/patch/QOLSYS.db
fi
#END-CHS

#if [  -f "/data/ver/systemPicVersion.txt" ]; then
# busybox rm /data/ver/systemPicVersion.txt
#fi
pictl r 0x6 0x2 > /data/ver/systemPicVersion.txt

#initialize the audio mixer, TODO:shouldn't enable headset and speaker both at the same time.
#Enable Speaker
amixer cset numid=7 127
amixer cset numid=37 1
amixer cset numid=40 1

#Enable Headset
amixer cset numid=5 0

# mount usbfs
mount -t usbfs none /proc/bus/usb

# prepare internal storage
mlcexpose /ubimount/internal.img 500 /internalstorage
#emmcexpose /dev/block/mmcblk0p4 /internalstorage

#START-CHS
# clean_error_log.sh &
#echo "Configuring IPTABLES Rules..."
# /system/bin/iptables.sh &

# Disable Bluetooth
chmod 000 /dev/ttyMSM0
chmod 000 /dev/ttyHS0

# stop market if running
busybox killall com.android.vending

# hardening TCP/IP stack for IPV4
busybox sysctl -w net.ipv4.icmp_echo_ignore_broadcasts=1 #ICMP broadcast
busybox sysctl -w net.ipv4.conf.all.accept_redirects=0 # ICMP redirects ipv4
busybox sysctl -w net.ipv6.conf.all.accept_redirects=0 #ICMP redirects ipv6
busybox sysctl -w net.ipv4.conf.all.send_redirects=0 # ICMP redirects
busybox sysctl -w net.ipv4.conf.all.accept_source_route=0 #source routing disable
busybox sysctl -w net.ipv4.conf.all.forwarding=0 #Forwarding traffic
busybox sysctl -w net.ipv4.conf.all.rp_filter=1
busybox sysctl -w net.ipv4.conf.all.log_martians=1 #filter martians
busybox sysctl -w net.ipv4.tcp_max_syn_backlog=1280 # TCP syn half-opened
busybox sysctl -w net.ipv4.ip_forward=0

# Removing/ disabling unnecessary binaries. Some of them have access to Internet
busybox rm -rf /system/xbin/*
chmod 000 /system/bin/bluetoothd
chmod 750 /system/bin/iptables
chmod 750 /system/bin/ping
chmod -s /system/bin/ping

reboot="N"

if [ -f "/system/app/hackersKeyboard.apk" ]; then
        busybox rm /system/app/hackersKeyboard.apk
        busybox rm /data/data/org.pocketworkstation.pckeyboard
	echo `date`" Deleting /system/app/hackersKeyboard.apk">>$DEBUG_LOG
        reboot="Y"
fi

busybox rm -rf /data/logs/**-**-**
busybox rm -rf /mnt/internalstorage/logs/**-**-**
busybox rm -rf /data/logs/adc
busybox rm -rf /mnt/internalstorage/logs/adc
busybox rm -rf /mnt/internalstorage/qolsysdb
busybox mv /data/media/ImageSensor/images/* /data/media/ImageSensor/
busybox rm -rf /data/media/ImageSensor/images/

if [ -f "/system/bin/cpulimit" ]; then
busybox rm /system/bin/cpulimit
echo `date`" Deleting /system/bin/cpulimit">>$DEBUG_LOG
reboot="Y"
fi

if [ -f "/system/bin/monkey" ]; then
        busybox rm /system/bin/monkey
	echo `date`" Deleting /system/bin/monkey">>$DEBUG_LOG
        reboot="Y"
fi


if [ -f "/system/app/Settings.apk" ]; then
    if [ -f "/data/app/Settings.apk" ]; then
        busybox rm /data/app/Settings.apk
	echo `date`" Deleting /data/app/Settings.apk">>$DEBUG_LOG
        reboot="Y"
    fi
fi

if [ -f "/system/app/CameraTests.apk" ]; then
   if [ -f "/data/app/CameraTests.apk" ]; then
	busybox rm /data/app/CameraTests.apk
	echo `date`" Deleting /data/app/CameraTests.apk">>$DEBUG_LOG
   fi
	busybox rm /system/app/CameraTests.apk
	echo `date`" Deleting /system/app/CameraTests.apk">>$DEBUG_LOG
	reboot="Y"
fi

if [ -f "/system/app/Browser.apk" ]; then
	busybox rm /system/app/Browser.apk
	echo `date`" Deleting /system/app/Browser.apk">>$DEBUG_LOG
	reboot="Y"
fi

if [ -f "/system/app/Launcher2.apk" ]; then
   if [ -f "/data/app/Launcher2.apk" ]; then
	busybox rm /data/app/Launcher2.apk
	echo `date`" Deleting /data/app/Launcher2.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/QolsysActivities.apk" ]; then
   if [ -f "/data/app/QolsysActivities.apk" ]; then
	busybox rm /data/app/QolsysActivities.apk
	echo `date`" Deleting /data/app/QolsysActivities.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/Upgrade.apk" ]; then
	busybox rm /system/app/Upgrade.apk
	echo `date`" Deleting /system/app/Upgrade.apk">>$DEBUG_LOG
   if [ -f "/data/app/Upgrade.apk" ]; then
	busybox rm /data/app/Upgrade.apk
	echo `date`" Deleting /data/app/Upgrade.apk">>$DEBUG_LOG
   fi
	reboot="Y"
fi

if [ -f "/system/app/ZWave.apk" ]; then
   if [ -f "/data/app/ZWave.apk" ]; then
	busybox rm /data/app/ZWave.apk
	echo `date`" Deleting /data/app/ZWave.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/Customer.apk" ]; then
   if [ -f "/data/app/Customer.apk" ]; then
	busybox rm /data/app/Customer.apk
	echo `date`" Deleting /data/app/Customer.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/Logs.apk" ]; then
   if [ -f "/data/app/Logs.apk" ]; then
	busybox rm /data/app/Logs.apk
	echo `date`" Deleting /data/app/Logs.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/PicoTts.apk" ]; then
   if [ -f "/data/app/PicoTts.apk" ]; then
	busybox rm /data/app/PicoTts.apk
	echo `date`" Deleting /data/app/PicoTts.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/QolSys.apk" ]; then
   if [ -f "/data/app/QolSys.apk" ]; then
	busybox rm /data/app/QolSys.apk
	echo `date`" Deleting /data/app/QolSys.apk">>$DEBUG_LOG
	reboot="Y"
   fi
fi

if [ -f "/system/app/UpdateTests.apk" ]; then
   if [ -f "/data/app/UpdateTests.apk" ]; then
	busybox rm /data/app/UpdateTests.apk
	echo `date`" Deleting /data/app/UpdateTests.apk">>$DEBUG_LOG
   fi
	busybox rm /system/app/UpdateTests.apk
	echo `date`" Deleting /system/app/UpdateTests.apk">>$DEBUG_LOG
	reboot="Y"
fi

if [ -f "/data/app/Music.apk" ]; then
	busybox rm /data/app/Music.apk
	echo `date`" Deleting /data/app/Music.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/data/app/video.apk" ]; then
	busybox rm /data/app/video.apk
	echo `date`" Deleting /data/app/video.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/data/app/DisarmPhotos.apk" ]; then
	busybox rm /data/app/DisarmPhotos.apk
	echo `date`" Deleting /data/app/DisarmPhotos.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/data/app/Gallery.apk" ]; then
	busybox rm /data/app/Gallery.apk
	echo `date`" Deleting /data/app/Gallery.apk">>$DEBUG_LOG
	reboot="Y"
fi

if [ -f "/system/app/LatinIME.apk" ]; then
    if [ -f "/data/app/LatinIME.apk" ]; then
        busybox rm /data/app/LatinIME.apk
	echo `date`" Deleting /data/app/LatinIME.apk">>$DEBUG_LOG
        reboot="Y"
    fi
elif [ -f "/data/app/LatinIME.apk" ]; then
        busybox mv /data/app/LatinIME.apk /system/app/LatinIME.apk
	chmod 777 /system/app/LatinIME.apk
	echo `date`" Moved LatinIME.apk from /data/app/ to /system/app/">>$DEBUG_LOG
        reboot="Y"
fi
if [ -f "/system/app/Camera.apk" ]; then
	busybox rm /system/app/Camera.apk
	echo `date`" Deleting /system/app/Camera.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/Contacts.apk" ]; then
	busybox rm /system/app/Contacts.apk
	echo `date`" Deleting /system/app/Contacts.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/ContactsProvider.apk" ]; then
	busybox rm /system/app/ContactsProvider.apk
	echo `date`" Deleting /system/app/ContactsProvider.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/foxdiag.apk" ]; then
	busybox rm /system/app/foxdiag.apk
	echo `date`" Deleting /system/app/foxdiag.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/Music.apk" ]; then
	busybox rm /system/app/Music.apk
	echo `date`" Deleting /system/app/Music.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/Fallback.apk" ]; then
	busybox rm /system/app/Fallback.apk
	echo `date`" Deleting /system/app/Fallback.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/NotePad.apk" ]; then
	busybox rm /system/app/NotePad.apk
	echo `date`" Deleting /system/app/NotePad.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/GenieWidget.apk" ]; then
	busybox rm /system/app/GenieWidget.apk
	echo `date`" Deleting /system/app/GenieWidget.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/LiveWallpapers.apk" ]; then
	busybox rm /system/app/LiveWallpapers.apk
	echo `date`" Deleting /system/app/LiveWallpapers.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/Term.apk" ]; then
	busybox rm /system/app/Term.apk
	echo `date`" Deleting /system/app/Term.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/Update.apk" ]; then
	busybox rm /system/app/Update.apk
	echo `date`" Deleting /system/app/Update.apk">>$DEBUG_LOG
	reboot="Y"
fi
if [ -f "/system/app/VpnServices.apk" ]; then
	busybox rm /system/app/VpnServices.apk
	echo `date`" Deleting /system/app/VpnServices.apk">>$DEBUG_LOG
	reboot="Y"
fi
	busybox rm /data/app/*
	echo `date`" Deleting /data/app/*">>$DEBUG_LOG

#if [ -f "/system/bin/shelld" ]; then
       # busybox rm /system/bin/shelld
	#echo `date`" Deleting /system/bin/shelld">>$DEBUG_LOG
       # reboot="Y"
#fi

if [ -f "/system/media/audio/ui/camera_click.ogg" ]; then
    busybox mv /system/media/audio/ui/camera_click.ogg /system/media/audio/ui/shutter_camera_click.ogg
fi

if [ -f "/system/media/audio/ui/VideoRecord.ogg" ]; then
    busybox mv /system/media/audio/ui/VideoRecord.ogg /system/media/audio/ui/VideoRecord_bkup.ogg
fi

#if [ -f "/data/data/com.qolsys.upgrade/files/zImage" ]; then
#    busybox mkdir /data/connupkefoxlwz
#    busybox mv /data/data/com.qolsys.upgrade/files/zImage /mnt/internalstorage/
#fi

if [ -f "/data/patch/zImage" ]; then
  busybox mkdir -p /data/patch/image922067582/
  busybox mv /data/patch/zImage /data/patch/image922067582/zImage
fi

echo `date`" Checking the system.tar.gz">>$DEBUG_LOG
TEMP_SYS_DIR="/data/patch/systemp/"
if [ -f "/data/data/com.qolsys.upgrade/files/system.tar.gz" ]; then
    echo `date`" sdcard upgrade: New system found. Copying to "$TEMP_SYS_DIR>>$DEBUG_LOG
    busybox mkdir -p $TEMP_SYS_DIR
    busybox mv /data/data/com.qolsys.upgrade/files/system.tar.gz $TEMP_SYS_DIR
elif [ -f "/data/data/com.qolsys/files/system.tar.gz" ]; then
    busybox mkdir -p $TEMP_SYS_DIR
    echo `date`" New system found. Copying to "$TEMP_SYS_DIR>>$DEBUG_LOG
    busybox mv /data/data/com.qolsys/files/system.tar.gz $TEMP_SYS_DIR
elif [ -f "/mnt/internalstorage/systemp/system.tar.gz" ]; then
    TEMP_SYS_DIR="/mnt/internalstorage/systemp/"
fi

echo `date`" Checking the data.tar.gz">>$DEBUG_LOG
TEMP_DATA_DIR="/mnt/internalstorage/temp_data/"
if [ -f "/data/data/com.qolsys.upgrade/files/data.tar.gz" ]; then
    echo `date`" sdcard upgrade: New data found. Copying to "$TEMP_DATA_DIR>>$DEBUG_LOG
    busybox mkdir -p $TEMP_DATA_DIR
    busybox mv /data/data/com.qolsys.upgrade/files/data.tar.gz $TEMP_DATA_DIR
elif [ -f "/data/data/com.qolsys/files/data.tar.gz" ]; then
    echo `date`" New data found. Copying to "$TEMP_DATA_DIR>>$DEBUG_LOG
    busybox mkdir -p $TEMP_DATA_DIR
    busybox mv /data/data/com.qolsys/files/data.tar.gz $TEMP_DATA_DIR
fi

if [ -f "/data/patch/calibrate922067582" ]; then
	busybox rm /data/etc/pointercal
        busybox rm -rf /data/patch/calibrate922067582
	echo `date`" Calibration Processed">>$DEBUG_LOG
	reboot="Y"
fi
## Temporarily added
#busybox rm -rf /data/data/com.qolsys.logs

if [ -f "/data/patch/ota" ]; then
 busybox rm "/data/patch/ota"
 if [ -f "/data/adcd/ota/update.zip" ]; then
    echo `date`" update.zip found. Applying it!">>$DEBUG_LOG
    wd.sh &
    updater 2 1 /data/adcd/ota/update.zip
    busybox mv /data/data/com.qolsys/databases/QOLSYS.db /data/patch/
    setprop UPGRADE_AVAILABLE 1
    busybox rm /data/adcd/ota/update.zip
    busybox echo 1 > /data/patch/upgrade
    echo `date`" update.zip applied successfully!">>$DEBUG_LOG
 fi
# busybox rm /data/patch/ota
 reboot="Y"
fi

if [ -f "/data/patch/wpa_supplicant.conf" ]; then
  busybox mv /data/patch/wpa_supplicant.conf /data/misc/wifi/
fi

chown system.wifi /data/misc/wifi/wpa_supplicant.conf
busybox chmod -R 777 /data/misc/wifi/

if [ -f "/data/patch/clear922067582" ]; then
    cd /
    busybox rm /data/patch/clear922067582
    busybox rm -rf /data/data/com.qolsys/
    busybox rm -rf /data/data/com.qolsys.zwave/databases/
    busybox rm -rf /data/dalvik-cache
    echo `date`" Secure Clear called">>$DEBUG_LOG
    reboot="Y"
elif [ -f "/data/patch/clean922067582" ]; then
    cd /
    busybox mkdir /mnt/sd1
    busybox mv /data/app /mnt/sd1
    busybox mv /data/etc /mnt/sd1
    busybox mv /data/adcd /mnt/sd1
    busybox mv /data/patch /mnt/sd1
    busybox mv /data/SRFpicVersion.db /mnt/sd1
    busybox find /data/system \! -name '*.dat' -delete 2>&-
    busybox mv /data/system /mnt/sd1

    busybox rm -rf /data/*
    busybox mv /mnt/sd1/app /data/
    busybox mv /mnt/sd1/etc /data/
    busybox mv /mnt/sd1/adcd /data/
    busybox mv /mnt/sd1/patch /data/
    busybox mv /mnt/sd1/SRFpicVersion.db /data/
    busybox mv /mnt/sd1/system /data/

    busybox rm -rf /mnt/sd1
    busybox rm -rf /data/patch/clean922067582
    busybox mkdir -p /data/errorLog
    busybox mkdir -p  /data/errorLog/upandroid
    busybox rm -rf  /mnt/internalstorage/alarms
    busybox rm -rf  /mnt/internalstorage/videoMemos
    busybox rm -rf  /data/media/disarmPhotos
    busybox rm -rf  /mnt/internalstorage/Panel_Music
    busybox rm -rf  /data/media/ImageSensor
    busybox rm -rf  /data/media/alarmPhotos
    busybox rm -rf  /mnt/internalstorage/logs
    busybox rm /data/patch/iqms.p12
    echo `date`" Master Reset called">>$DEBUG_LOG
    reboot="Y"
elif [ -d "/data/patch/image922067582" ]; then
    echo `date`" Applying patch">>$DEBUG_LOG
    busybox cp /data/data/com.qolsys/databases/QOLSYS.db /data/patch/
    cd /system/bin
    if [ -f "/data/patch/image922067582/install922067582.sh" ]; then
      chmod 777 /data/patch/image922067582/install922067582.sh 
      sh /data/patch/image922067582/install922067582.sh 
    fi
    if [ -f "/data/patch/image922067582/zImage" ]; then
    echo `date`" zImage exists.">>$DEBUG_LOG
    busybox mkdir -p /data/tmp922067582
    #busybox rm -rf /data/errorLog/upkernel.log

    #date >>/data/errorLog/upkernel.log
    echo `date`" Qolsys start kernel upgrade!">>$DEBUG_LOG

    judk
    #if [ $? -eq 0 ]; then
          echo `date`" mount to partition 5!">>$DEBUG_LOG
          busybox mount /dev/block/mmcblk0p5 /data/tmp922067582
		  busybox cp /data/patch/image922067582/zImage /data/tmp922067582/boot/
    #else
          echo `date`" mount to partition 1!"
		  umount /data/tmp922067582
          busybox mount /dev/block/mmcblk0p1 /data/tmp922067582/
		  busybox mv /data/patch/image922067582/zImage /data/tmp922067582/boot/
    #fi
        #busybox rm -rf /data/tmp922067582/boot/zImage
        #busybox mv /data/patch/image922067582/zImage /data/tmp922067582/boot/
        #busybox rm -rf /mnt/internalstorage/image922067582/zImage  
    russk

    echo `date`" kernel upgrade ends!">>$DEBUG_LOG
        umount /data/tmp922067582
        busybox rm -rf /data/tmp922067582 
    else
        echo `date`" zImage is not exist!">>$DEBUG_LOG
    fi
    busybox rm -rf /data/patch/image922067582
#    busybox rm /data/install922067582.sh
    busybox rm -rf /data/data/com.qolsys/databases/
    busybox rm -rf /data/data/com.qolsys/files/*
#    busybox rm -rf /data/data/com.qolsys.logs
    busybox rm -rf /data/dalvik-cache
#    busybox rm -rf /data/system
     busybox find /data/system \! -name '*.dat' -delete 2>&-
    
    setprop UPGRADE_AVAILABLE 1
    busybox echo 1 > /data/patch/upgrade
    echo `date`" Qolsys patch applied successfully!">>$DEBUG_LOG

	if [ -f "/system/lib/libcrypto.so" ]; then
	  busybox rm /system/lib/libcrypto.so
	fi

	if [ -f "/system/lib/libssl.so" ]; then
	  busybox rm /system/lib/libssl.so
	fi

	ln -s /system/lib/libcrypto.so.1.0.0 /system/lib/libcrypto.so
    	ln -s /system/lib/libssl.so.1.0.0 /system/lib/libssl.so

    reboot="Y"
#END-CHS
##################################
elif [ -d "/data/connupkefoxlwz" ]; then
  busybox rm -rf /data/connupkefoxlwz
#  busybox rm -rf /data/errorLog/upkernel.log
  FS=`busybox stat -c%s /data/errorLog/upkernel.log`
  if [ $FS -gt 100000 ]; then
    busybox rm -rf /data/errorLog/upkernel.log
  fi

  echo "KERNEL_UPDATE_TIME:">>/data/errorLog/upkernel.log
  date >>/data/errorLog/upkernel.log
  echo "start kernel upgrade!">>/data/errorLog/upkernel.log
  cd /
  mkdir /mnt/sd1
  mkdir /mnt/sd4
  busybox mount /dev/block/mmcblk0p7 /mnt/sd4

  if [ -f "/mnt/sd4/zImage" ]; then
    judk
    if [ $? -eq 0 ]; then
      echo "KERNEL_ACTIVE_PARTITION:">>/data/errorLog/upkernel.log
      echo "partition 5!">>/data/errorLog/upkernel.log
      busybox mount /dev/block/mmcblk0p5 /mnt/sd1
      busybox rm -rf /mnt/sd1/boot/zImage
      busybox cp /mnt/sd4/zImage /mnt/sd1/boot/
      #busybox rm -rf /mnt/sd4/zImage
    else
      echo "KERNEL_ACTIVE_PARTITION:">>/data/errorLog/upkernel.log
      echo "partition 1!">>/data/errorLog/upkernel.log
      busybox mount /dev/block/mmcblk0p1 /mnt/sd1
      busybox rm -rf /mnt/sd1/boot/zImage
      busybox cp /mnt/sd4/zImage /mnt/sd1/boot/
     # busybox rm -rf /mnt/sd4/zImage
    fi
    russk

    echo "kernel remove sds!">>/data/errorLog/upkernel.log
  else
    echo "zImage is not exist!">>/data/errorLog/upkernel.log
  fi
  umount /mnt/sd1
  umount /mnt/sd4
  busybox rm -rf /mnt/sd1 /mnt/sd4
  reboot="Y"
#####################################
elif [ -d "/data/connupanfoxlwz" ]; then
  busybox rm -rf /data/connupanfoxlwz
  FS=`busybox stat -c%s /data/errorLog/upandroid/upandroid.log`
  if [ $FS -gt 100000 ]; then
    busybox rm -rf /data/errorLog/upandroid/upandroid.log
  fi
#  busybox rm -rf /data/errorLog/upandroid/upandroid.log

  echo "SYSTEM_UPDATE_TIME:">>/data/errorLog/upandroid/upandroid.log
  date >>/data/errorLog/upandroid/upandroid.log
  echo "start android upgrade!">>/data/errorLog/upandroid/upandroid.log
  cd /
  mkdir /mnt/sd1
  mkdir /mnt/sd4
  mkdir /mnt/sd26
  busybox mount /dev/block/mmcblk0p1 /mnt/sd1
  busybox mount /dev/block/mmcblk0p7 /mnt/sd4
  if [ -f "/mnt/sd4/system.tar.gz" ]; then
    echo "start system upgrade!">>/data/errorLog/upandroid/upandroid.log
    wdclr
    hwapitest c wdclr>>/dev/ttyS1
    juda
	 if [ $? -eq 0 ]; then
      echo "SYSTEM_ACTIVE_PARTITION:">>/data/errorLog/upandroid/upandroid.log
      echo "partition 6!">>/data/errorLog/upandroid/upandroid.log
      busybox mount /dev/block/mmcblk0p6 /mnt/sd26
	 
      busybox rm -rf /mnt/sd26/*
      busybox tar -zxvf /mnt/sd4/system.tar.gz -C /mnt/sd26/
      busybox mv /mnt/sd26/system/* /mnt/sd26/
      busybox rm -rf /mnt/sd26/system
	  busybox chmod -R 777 /mnt/sd26/app/
      busybox chmod 4755 /mnt/sd26/bin/busybox
#      busybox rm -rf /mnt/sd4/system.tar.gz
      echo "install system over 6!">>/data/errorLog/upandroid/upandroid.log
    else
      echo "SYSTEM_ACTIVE_PARTITION:">>/data/errorLog/upandroid/upandroid.log
      echo "partition 2!">>/data/errorLog/upandroid/upandroid.log
      busybox mount /dev/block/mmcblk0p2 /mnt/sd26
      busybox rm -rf /mnt/sd26/*
      busybox tar -zxvf /mnt/sd4/system.tar.gz -C /mnt/sd26/
      busybox mv /mnt/sd26/system/* /mnt/sd26/
      busybox rm -rf /mnt/sd26/system
	  busybox chmod -R 777 /mnt/sd26/app/
      busybox chmod 4755 /mnt/sd26/bin/busybox
#      busybox rm -rf /mnt/sd4/system.tar.gz
      echo "install system over 2!">>/data/errorLog/upandroid/upandroid.log
    fi
    russa

  else
    echo "system.tar.gz is not exist!">>/data/errorLog/upandroid/upandroid.log
  fi

  if [ -f "/mnt/sd4/data.tar.gz" ]; then
    echo "start data upgrade!">>/data/errorLog/upandroid/upandroid.log
    busybox cp /data/errorLog/upandroid/upandroid.log /mnt/sd4/
    busybox cp /data/errorLog/upkernel.log /mnt/sd4/
    busybox rm -rf /data/*
    mkdir /data/errorLog
    mkdir /data/errorLog/upandroid
    busybox cp /mnt/sd4/upandroid.log /data/errorLog/upandroid/
    busybox cp /mnt/sd4/upkernel.log /data/errorLog/
    busybox tar -zxvf /mnt/sd4/data.tar.gz -C /data/
    busybox mv /data/data/* /data/
    busybox rm -rf /data/data
    busybox chmod -R 777 /data/
#    busybox rm -rf /mnt/sd4/data.tar.gz
    echo "install data over!">>/data/errorLog/upandroid/upandroid.log
  else
    echo "data.tar.gz is not exist!">>/data/errorLog/upandroid/upandroid.log
  fi

  echo "android remove sds!">>/data/errorLog/upandroid/upandroid.log
  umount /mnt/sd1
  umount /mnt/sd4
  umount /mnt/sd26
  busybox rm -rf /mnt/sd1 /mnt/sd4 /mnt/sd26
  reboot="Y"
########################################
elif [ -d "/data/connupqolfoxlwz" ]; then
  busybox rm -rf /data/connupqolfoxlwz

  date >>/data/errorLog/upandroid/upandroid.log
  echo "lwz update qolsys!">>/data/errorLog/upandroid/upandroid.log
  cd /
  mkdir /mnt/sd4
  busybox mount /dev/block/mmcblk0p7 /mnt/sd4

  if [ -f "/mnt/sd4/QolSys.apk" ]; then
    echo "QolSys.apk is exist!">>/data/errorLog/upandroid/upandroid.log
    busybox rm -rf /data/app/QolSys.apk
    busybox cp /mnt/sd4/QolSys.apk /data/app/
    chmod 777 /data/app/QolSys.apk
  else
    echo "QolSys.apk is not exist!">>/data/errorLog/upandroid/upandroid.log
  fi

  umount /mnt/sd4
  busybox rm -rf /mnt/sd4
  reboot="Y"
fi
### CHS STARTS ###
if [ -f $TEMP_SYS_DIR"/system.tar.gz" ]; then
  echo `date`" Applying system.tar.gz">>$DEBUG_LOG
  cd /
  echo `date`" Qolsys system upgrade start!">>$DEBUG_LOG
  wdclr
  hwapitest c wdclr>>/dev/ttyS1
  busybox cp /system/bin/busybox /mnt/
  /mnt/busybox rm -rf /system/*

  /mnt/busybox tar -zxvf $TEMP_SYS_DIR/system.tar.gz -C /system/
  /mnt/busybox mv /system/system/* /system/
  /mnt/busybox rm -rf /system/system
  /mnt/busybox chmod -R 777 /system/app/
  /mnt/busybox chmod 4755 /system/bin/busybox
  busybox rm -rf $TEMP_SYS_DIR
  busybox rm -rf /data/patch/system_manifest.txt
  echo `date`" Qolsys system upgrade ends!">>$DEBUG_LOG
  reboot="Y"
fi

if [ -f $TEMP_DATA_DIR"/data.tar.gz" ]; then
    echo `date`" Qolsys data upgrade starts!">>$DEBUG_LOG
busybox mkdir -p /data/patch/shared_prefs/
    busybox cp /data/data/com.qolsys/shared_prefs/*.xml /data/patch/shared_prefs/
    busybox cp /data/data/com.qolsys/databases/QOLSYS.db /data/patch/
    busybox mv /data/misc/wifi/wpa_supplicant.conf /data/patch/

    busybox mv /data/errorLog/ $TEMP_DATA_DIR
    busybox mv /data/etc/ $TEMP_DATA_DIR
    busybox mv /data/logs/ $TEMP_DATA_DIR
    busybox mv /data/patch/ $TEMP_DATA_DIR
    busybox find /data/system \! -name '*.dat' -delete 2>&-
    busybox mv /data/system $TEMP_DATA_DIR

    busybox rm -rf /data/*
    busybox tar -zxvf $TEMP_DATA_DIR/data.tar.gz -C /data/
    busybox mv /data/data/* /data/
    busybox mv $TEMP_DATA_DIR/errorLog/ /data/
    busybox mv $TEMP_DATA_DIR/etc/ /data/
    busybox mv $TEMP_DATA_DIR/logs/ /data/
    busybox mv $TEMP_DATA_DIR/patch/ /data/
    busybox mv $TEMP_DATA_DIR/system/ /data/
    #busybox mv $TEMP_DATA_DIR/misc/ /data/
    #busybox mv /data/misc/wifi/ $TEMP_DATA_DIR
    #busybox rm -rf /data/misc/*
    #busybox mv $TEMP_DATA_DIR/wifi/ /data/misc/
    busybox rm -rf /data/data
    busybox rm /data/patch/iqms.p12
    busybox chmod -R 777 /data/
    busybox rm -rf $TEMP_DATA_DIR
    if [ ! -f "/data/patch/recov" ]; then
     busybox echo 2 > /data/patch/upgrade
    fi
    echo `date`" Qolsys data install over!">>$DEBUG_LOG
    reboot="Y"
fi

if [ "$reboot" = "Y" ]; then
    echo `date`" Rebooting the panel">>$DEBUG_LOG
    busybox mkdir -p /data/patch/
    echo 1 > /data/patch/rmdalvik.txt
    reboot
else
    system_mount=`busybox mount | busybox grep /system |busybox cut -d"(" -f2 | busybox cut -d"," -f1`
    if [ "$system_mount" = "rw" ]; then
      echo `date`" system partition is mounted as RW">>$DEBUG_LOG
    else
      echo `date`" system partition is mounted as RO">>$DEBUG_LOG
    fi

    data_mount=`busybox mount | busybox grep /data |busybox cut -d"(" -f2 | busybox cut -d"," -f1`
    if [ "$data_mount" = "rw" ]; then
      echo `date`" data partition is mounted as RW">>$DEBUG_LOG
    else
      echo `date`" data partition is mounted as RO">>$DEBUG_LOG
    fi

    internal_st_mount=`busybox mount | busybox grep /dev/block/mmcblk0p7 |busybox cut -d"(" -f2 | busybox cut -d"," -f1`
    if [ "$internal_st_mount" = "rw" ]; then
      echo `date`" /mnt/internalstorage partition is mounted as RW">>$DEBUG_LOG
    else
      echo `date`" /mnt/internalstorage partition is mounted as RO">>$DEBUG_LOG
    fi

    if [ -f /data/patch/rmdalvik.txt ]; then
	rm /data/patch/rmdalvik.txt
    else
        echo `date`" Cleaning up dalvik-cache and system..">>$DEBUG_LOG
	busybox rm -rf /data/dalvik-cache
#	busybox rm -rf /data/system
	busybox find /data/system \! -name '*.dat' -delete 2>&-
	echo 1 > /data/patch/rmdalvik.txt
	reboot
    fi

    date >>$DEBUG_LOG
    echo "update status is not set!">>$DEBUG_LOG
    wd.sh&
    tampState.sh &
    /system/bin/shelldmon &
    busybox chmod 777 /system/etc/security/
    busybox chmod 777 /system/etc/
    busybox sh /system/bin/removeCert.sh
    /system/bin/runServerCert &
    /system/bin/mbroker &
    /system/bin/remotecommd &
    busybox sh /system/bin/integ_check.sh
    intg_result=`getprop qol.integrity_test_result`
    if busybox test $intg_result -eq 1
	then
		echo 'System Integrity Test passed.'>>$DEBUG_LOG
	else
		echo 'System Integrity Test failed. Check the file /data/errorLog/checksum_mismatch.json for details'>>$DEBUG_LOG
	fi
fi

#START-CHS
echo `date`" Remounting system as Read Only">>$DEBUG_LOG
busybox mount -o ro -o remount /system
################################
# Configure IPTABLES Rules
################################
# For debugging use iptables -v.
IPTABLES="/system/bin/iptables"

echo -n ">> Applying Iptables Rules... "

# Logging options.
#------------------------------------------------------------------------------
#LOG="LOG --log-level debug --log-tcp-sequence --log-tcp-options"
#LOG="$LOG --log-ip-options"
 
# Cleanup.
#------------------------------------------------------------------------------
 
# Delete all
$IPTABLES -F
$IPTABLES -t mangle -F
 
# Delete all
$IPTABLES -X
$IPTABLES -t mangle -X
 
# Zero all packets and counters.
$IPTABLES -Z
$IPTABLES -t mangle -Z
 
# Defaults for rate limiting
#------------------------------------------------------------------------------
RLIMIT="-m limit --limit 3/s --limit-burst 8"
 
# Unprivileged ports.
#------------------------------------------------------------------------------
PHIGH="2000:65535"
PSSH="1000:1023"
 
# Kernel Protection.
#------------------------------------------------------------------------------
 
# IP forwarding.
# On => Off = (reset)
echo 1 > /proc/sys/net/ipv4/ip_forward
# echo 0 > /proc/sys/net/ipv4/ip_forward
 
# Enable IP spoofing protection
for i in /proc/sys/net/ipv4/conf/*/rp_filter; do echo 1 > $i; done
  
# Ignore all incoming ICMP echo requests
echo 0 > /proc/sys/net/ipv4/icmp_echo_ignore_all
 
# Ignore ICMP echo requests to broadcast
echo 1 > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
 
# Log packets with impossible addresses.
for i in /proc/sys/net/ipv4/conf/*/log_martians; do echo 1 > $i; done
 
# Don't log invalid responses to broadcast
echo 1 > /proc/sys/net/ipv4/icmp_ignore_bogus_error_responses
 
# Don't accept or send ICMP redirects.
for i in /proc/sys/net/ipv4/conf/*/accept_redirects; do echo 0 > $i; done
for i in /proc/sys/net/ipv4/conf/*/send_redirects; do echo 0 > $i; done
 
# Don't accept source routed packets.
for i in /proc/sys/net/ipv4/conf/*/accept_source_route; do echo 0 > $i; done
 
# Disable proxy_arp.
for i in /proc/sys/net/ipv4/conf/*/proxy_arp; do echo 0 > $i; done
 
# Enable secure redirects, i.e. only accept ICMP redirects for gateways
# Helps against MITM attacks.
for i in /proc/sys/net/ipv4/conf/*/secure_redirects; do echo 1 > $i; done
 
# Disable bootp_relay
for i in /proc/sys/net/ipv4/conf/*/bootp_relay; do echo 0 > $i; done

#
# #######################################################################################################################
# iptables-anti-attack-measures-policies
# #######################################################################################################################
#
# In the following section set it 1 to enable the feature or 0 to disable the feature
#
# Drop ICMP echo-request messages sent to broadcast or multicast addresses
echo 1 > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
#
# Drop source routed packets
echo 0 > /proc/sys/net/ipv4/conf/all/accept_source_route
#
 
# Default policies.
#------------------------------------------------------------------------------
 
# Drop everything by default 
# and Allow Outgoing traffic
$IPTABLES -P INPUT DROP
$IPTABLES -P FORWARD DROP
#$IPTABLES -P OUTPUT DROP
$IPTABLES -P OUTPUT ACCEPT
 
# Set the nat/mangle/raw tables' chains to ACCEPT
#$IPTABLES -t nat -P PREROUTING ACCEPT
#$IPTABLES -t nat -P OUTPUT ACCEPT
#$IPTABLES -t nat -P POSTROUTING ACCEPT
 
$IPTABLES -t mangle -P PREROUTING ACCEPT
$IPTABLES -t mangle -P INPUT ACCEPT
$IPTABLES -t mangle -P FORWARD ACCEPT
$IPTABLES -t mangle -P OUTPUT ACCEPT
$IPTABLES -t mangle -P POSTROUTING ACCEPT

# Filtering
 
# ToDo - IPv6 Support
#------------------------------------------------------------------------------
 
# LOG packets, then ACCEPT.
#$IPTABLES -N ACCEPTLOG
#$IPTABLES -A ACCEPTLOG -j $LOG $RLIMIT --log-prefix "ACCEPT "
#$IPTABLES -A ACCEPTLOG -j ACCEPT
 
# LOG packets, then DROP.
#$IPTABLES -N DROPLOG
#$IPTABLES -A DROPLOG -j $LOG $RLIMIT --log-prefix "DROP "
#$IPTABLES -A DROPLOG -j DROP
 
# LOG packets, then REJECT.
# TCP packets are rejected with a TCP reset.
#$IPTABLES -N REJECTLOG
#$IPTABLES -A REJECTLOG -j $LOG $RLIMIT --log-prefix "REJECT "
#$IPTABLES -A REJECTLOG -p tcp -j REJECT --reject-with tcp-reset
#$IPTABLES -A REJECTLOG -j REJECT
 
# Selectively allow certain special types of traffic.
#------------------------------------------------------------------------------

# Allow loopback interface to do anything.
$IPTABLES -A INPUT -i lo -j ACCEPT
$IPTABLES -A OUTPUT -o lo -j ACCEPT

# Allow ssh access to sshers
#------------------------------------------------------------------------------
sshers=""
for ssher in $sshers ; do
    $IPTABLES -A INPUT -s $ssher -p tcp -m tcp --dport 22 -j ACCEPT
    $IPTABLES -A OUTPUT -d $ssher -p tcp -m tcp --sport 22 -j ACCEPT
done
 
# DNS
#------------------------------------------------------------------------------
$IPTABLES -A INPUT -p udp -m udp --sport 53 -j ACCEPT
$IPTABLES -A OUTPUT -p udp -m udp --dport 53 -j ACCEPT

# HTTP & HTTPS
$IPTABLES -I INPUT 1 -p tcp --dport 80 -j ACCEPT
$IPTABLES -I INPUT 1 -p tcp --dport 443 -j ACCEPT
$IPTABLES -I OUTPUT 1 -p tcp --dport 80 -j ACCEPT
$IPTABLES -I OUTPUT 1 -p tcp --dport 443 -j ACCEPT
$IPTABLES -A OUTPUT -p tcp -m tcp --dport 8080 -j ACCEPT
$IPTABLES -A INPUT -p tcp -m tcp --sport 8080 -j ACCEPT
# QOLSYS CHANGE
#$IPTABLES -I INPUT -p tcp --dport 8443 -j DROP
#######################################################################################################################
# Only allows RELATED ICMP types
# (destination-unreachable, time-exceeded, and parameter-problem).
# icmp, INPUT and ports setup
#######################################################################################################################
#
$IPTABLES -A INPUT -p icmp -m icmp --icmp-type 3 -j ACCEPT
$IPTABLES -A INPUT -p icmp -m icmp --icmp-type 11 -j ACCEPT
$IPTABLES -A INPUT -p icmp -m icmp --icmp-type 4 -j ACCEPT
$IPTABLES -A INPUT -p icmp -m icmp --icmp-type 12 -j ACCEPT

$IPTABLES -I INPUT -p icmp --icmp-type 8 -j DROP
$IPTABLES -A INPUT -p icmp --icmp-type 5 -j DROP
$IPTABLES -A INPUT -p icmp --icmp-type echo-request -j DROP
 
# Make It Even Harder To Multi-PING
$IPTABLES  -A INPUT -p icmp -m limit --limit 1/s --limit-burst 2 -j ACCEPT
$IPTABLES  -A INPUT -p icmp -m limit --limit 1/s --limit-burst 2 -j LOG --log-prefix PING-DROP:
$IPTABLES  -A INPUT -p icmp -j DROP
$IPTABLES  -A OUTPUT -p icmp -j ACCEPT

#
# #######################################################################################################################
# Securing INPUT
# #######################################################################################################################
#
$IPTABLES -N SYN_FLOOD
$IPTABLES -A INPUT -p tcp --syn -j SYN_FLOOD
$IPTABLES -A SYN_FLOOD -m limit --limit 2/s --limit-burst 6 -j RETURN
$IPTABLES -A SYN_FLOOD -j DROP

# All of the bits are cleared
$IPTABLES -A INPUT -p tcp --tcp-flags ALL NONE -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags FIN,SYN,RST,PSH,ACK,URG NONE -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags FIN,SYN FIN,SYN -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags SYN,RST SYN,RST -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags FIN,RST FIN,RST -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags FIN,ACK FIN -j DROP
$IPTABLES -A INPUT -p tcp -m tcp --tcp-flags ACK,URG URG -j DROP
# FIN is the only bit set, without the expected accompanying ACK
$IPTABLES -A INPUT -p tcp --tcp-flags ACK,FIN FIN -j DROP
# PSH is the only bit set, without the expected accompanying ACK
$IPTABLES -A INPUT -p tcp --tcp-flags ACK,PSH PSH -j DROP
# $IPTABLES -A INPUT -p tcp -m tcp ! --tcp-flags FIN,SYN,RST,ACK SYN -m state --state NEW -j DROP

# Prevent DoS Attack
#------------------------------------------------------------------------------
$IPTABLES -A INPUT -p tcp --dport 80 -m limit --limit 25/minute --limit-burst 100 -j ACCEPT
 
# Drop any traffic from IANA-reserved IPs.
#------------------------------------------------------------------------------
echo "drop traffic"
$IPTABLES -A INPUT -s 0.0.0.0/7 -j DROP
#$IPTABLES -A INPUT -s 10.0.0.0/8 -j DROP
$IPTABLES -A INPUT -s 100.64.0.0/10 -j DROP
$IPTABLES -A INPUT -s 127.0.0.0/8 -j DROP
$IPTABLES -A INPUT -s 169.254.0.0/16 -j DROP
$IPTABLES -A INPUT -s 192.0.0.0/29 -j DROP 
$IPTABLES -A INPUT -s 192.0.2.0/24 -j DROP 
$IPTABLES -A INPUT -s 192.88.99.0/24 -j DROP 
$IPTABLES -A INPUT -s 198.18.0.0/15 -j DROP 
$IPTABLES -A INPUT -s 198.51.100.0/24 -j DROP 
$IPTABLES -A INPUT -s 203.0.113.0/24 -j DROP 
$IPTABLES -A INPUT -s 224.0.0.0/4 -j DROP 
$IPTABLES -A INPUT -s 240.0.0.0/4 -j DROP 
$IPTABLES -A INPUT -s 255.255.255.255/32 -j DROP

# Unpriviledged Ports
#------------------------------------------------------------------------------
$IPTABLES -A INPUT -p tcp -m tcp --dport $PHIGH -j ACCEPT
$IPTABLES -A INPUT -p udp -m udp --dport $PHIGH -j ACCEPT

#END-CHS
